<template>
  <div class="q-pa-md">
    <q-table
      card-class="text-black"
      wrap-cells
      virtual-scroll-sticky-size-start
      title="Users"
      :rows="rows"
      :columns="columns"
      row-key="id"
      virtual-scroll
      separator="cell"
      :rows-per-page-options="[0]"
    >
      <!--Display Table with five user information-->
      <template #body="props">
        <q-tr :props="props">
          <q-td key="name" :props="props"> {{ props.row.name }}</q-td>
          <q-td key="username" :props="props"> {{ props.row.username }}</q-td>
          <q-td key="email" :props="props"> {{ props.row.email }}</q-td>
          <q-td key="address" :props="props"> {{ props.row.address }}</q-td>
          <q-td key="phone" :props="props"> {{ props.row.phone }}</q-td>
          <q-td key="bs" :props="props"> {{ props.row.bs }}</q-td>
          <q-td key="action" :props="props">
            <!--Button opens a dialog to show all user details-->
            <q-btn
              flat
              round
              icon="info"
              dense
              color="info"
              @click="toggleInfoDialog(props.row)"
              ><q-tooltip class="bg-accent">Show Info</q-tooltip></q-btn
            >
            <!--Button routes the user to AddUserPage to edit user info-->
            <q-btn
              flat
              round
              icon="edit"
              dense
              color="positive"
              @click="toggleEditDialog(props.row)"
              ><q-tooltip class="bg-accent">Edit User</q-tooltip></q-btn
            >
            <!--Button to delete user-->
            <q-btn
              flat
              round
              icon="delete"
              dense
              color="negative"
              @click="toggleDeleteDialog(props.row)"
              ><q-tooltip class="bg-accent">Delete User</q-tooltip></q-btn
            >
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
  <!--Info Dialog-->
  <q-dialog v-model="showInfoDialog" persistent>
    <q-card style="max-width: 1000px; width: 1000px; height: 730px">
      <q-card-section>
        <div class="text-h6 text-primary text-weight-bold">
          {{ dialogData.name }}'s Personal Info
        </div>
      </q-card-section>
      <q-separator />
      <q-card-section class="scroll">
        <!--Personal Info-->
        <div class="row">
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Name" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.name }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Username" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.username }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Email" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.email }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Phone No." stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.phone }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Website" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.website }}
              </div>
            </q-field>
          </div>
        </div>
        <h1 class="text-h6 text-weight-bold text-primary">Address</h1>
        <div class="row">
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Street" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.street }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Suite" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.suite }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="City" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.city }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Zipcode" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.zipcode }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Latitude" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.geo.lat }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Longitude" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.address.geo.lng }}
              </div>
            </q-field>
          </div>
        </div>
        <h1 class="text-h6 text-weight-bold text-primary">Company</h1>
        <div class="row">
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Company Name" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.company.name }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="Catchphrase" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.company.catchPhrase }}
              </div>
            </q-field>
          </div>
          <div class="col-xs-12 col-sm-6 col-sm-4">
            <q-field borderless label="BS" stack-label>
              <div class="self-center full-width no-outline text-black">
                {{ dialogData.company.bs }}
              </div>
            </q-field>
          </div>
        </div>
      </q-card-section>
      <q-separator />
      <q-card-actions align="right">
        <q-btn flat label="Close" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>
  <!--Edit Dialog-->
  <q-dialog v-model="showEditDialog" persistent maximized
    ><q-card>
      <div
        style="max-width: 56rem; margin: 0 auto; padding-bottom: 3rem"
        class="column items-center q-mt-xs"
      >
        <q-form
          ref="form"
          autofocus
          style="max-width: 56rem"
          class="row q-px-lg q-gutter-x-sm"
        >
          <div class="col-12">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              {{ dialogData.name }}'s Personal Details
            </h1>
            <div class="row q-gutter-xs">
              <q-input
                class="col-12 col-md-4"
                outlined
                dense
                v-model="dialogData.name"
                label="Name"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />

              <q-input
                class="col-12 col-md-4"
                outlined
                dense
                v-model="dialogData.username"
                label="Username"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-3"
                outlined
                dense
                v-model="dialogData.email"
                label="Email"
                type="email"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="dialogData.phone"
                label="Phone Number"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="dialogData.website"
                label="Website"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <div class="col-12">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              Address
            </h1>
            <div class="row q-gutter-xs">
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="dialogData.address.street"
                label="Street"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="dialogData.address.suite"
                label="Suite"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="dialogData.address.city"
                label="City"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="dialogData.address.zipcode"
                label="ZIP Code"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <div class="col-12" style="width: 100%">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              Company
            </h1>
            <div class="row q-gutter-sm">
              <q-input
                class="col-12 col-md-11"
                outlined
                dense
                v-model="dialogData.company.name"
                label="Company Name"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="dialogData.company.catchPhrase"
                label="Catchphrase"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="dialogData.company.bs"
                label="BS"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <q-btn
            color="primary"
            class="col-6 q-mt-lg"
            label="Update"
            @click="updateData()"
            v-close-popup
          />
          <q-btn
            color="negative"
            class="col-5 q-mt-lg"
            label="Cancel"
            v-close-popup
          />
        </q-form></div
    ></q-card>
  </q-dialog>
  <!--Delete Dialog-->
  <q-dialog v-model="showDeleteDialog" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <div class="q-ml-sm">Are you sure you want to delete?</div>
      </q-card-section>

      <q-card-actions align="center">
        <q-btn flat label="CANCEL" color="primary" v-close-popup />
        <q-btn
          label="YES"
          rounded
          :loading="deleteBtnLoadingState"
          color="primary"
          @click="deleteData()"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ref } from "vue";
import {
  tableData,
  getUserData,
  updateData,
  deleteData,
  resetValidation,
  requiredInput,
  deleteBtnLoadingState,
  btnLoadingState,
} from "../composables/axiosData";

let selectedRow = ref({});
let rows = ref([]);
let currentDialogForm = ref(1);
let dialogData = ref({
  name: null,
  username: null,
  email: null,
  address: {
    street: null,
    suite: null,
    city: null,
    zipcode: null,
    geo: {
      lat: null,
      lng: null,
    },
  },
  phone: null,
  website: null,
  company: {
    name: null,
    catchPhrase: null,
    bs: null,
  },
});

let showEditDialog = ref(false);
let showDeleteDialog = ref(false);
let showInfoDialog = ref(false);

export default {
  setup() {
    let columns = ref([
      {
        name: "name",
        label: "Name",
        align: "left",
        field: "name",
      },
      {
        name: "username",
        label: "Username",
        align: "left",
        field: "username",
      },
      {
        name: "email",
        label: "Email",
        align: "left",
        field: "email",
      },
      {
        name: "address",
        label: "Address",
        align: "left",
        field: "address",
      },
      {
        name: "phone",
        label: "Phone No.",
        align: "left",
        field: "phone",
      },
      {
        name: "action",
        label: "Options",
        align: "center",
        field: "action",
      },
    ]);

    let sliceAddress = (address) => {
      const parts = address
        .split(/[,()]/)
        .map((part) => part.trim())
        .filter((part) => part.length > 0);
      return parts;
    };
    const toggleInfoDialog = (row) => {
      selectedRow.value = row;
      dialogData.value.name = row.name;
      dialogData.value.username = row.username;
      dialogData.value.email = row.email;
      dialogData.value.phone = row.phone;
      dialogData.value.website = row.website;

      let slicedAddress = sliceAddress(row.address);
      dialogData.value.address.street = slicedAddress[0];
      dialogData.value.address.suite = slicedAddress[1];
      dialogData.value.address.city = slicedAddress[2];
      dialogData.value.address.zipcode = slicedAddress[3];
      dialogData.value.address.geo.lat = row.latitude;
      dialogData.value.address.geo.lng = row.longitude;
      dialogData.value.company.name = row.company;
      dialogData.value.company.catchPhrase = row.catchPhrase;
      dialogData.value.company.bs = row.bs;
      showInfoDialog.value = true;
    };
    const toggleEditDialog = (row) => {
      selectedRow.value = row;
      dialogData.value.name = row.name;
      dialogData.value.username = row.username;
      dialogData.value.email = row.email;
      dialogData.value.phone = row.phone;
      dialogData.value.website = row.website;

      let slicedAddress = sliceAddress(row.address);
      dialogData.value.address.street = slicedAddress[0];
      dialogData.value.address.suite = slicedAddress[1];
      dialogData.value.address.city = slicedAddress[2];
      dialogData.value.address.zipcode = slicedAddress[3];
      dialogData.value.address.geo.lat = row.latitude;
      dialogData.value.address.geo.lng = row.longitude;
      dialogData.value.company.name = row.company;
      dialogData.value.company.catchPhrase = row.catchPhrase;
      dialogData.value.company.bs = row.bs;
      showEditDialog.value = true;
    };

    const toggleDeleteDialog = (row) => {
      selectedRow.value = row;
      showDeleteDialog.value = true;
    };

    return {
      rows,
      columns,
      getUserData,
      tableData,
      showEditDialog,
      toggleEditDialog,
      dialogData,
      currentDialogForm,
      sliceAddress,
      updateData,
      toggleDeleteDialog,
      showDeleteDialog,
      deleteData,
      resetValidation,
      deleteBtnLoadingState,
      btnLoadingState,
      showInfoDialog,
      toggleInfoDialog,
    };
  },
};

export {
  rows,
  dialogData,
  selectedRow,
  currentDialogForm,
  deleteData,
  showEditDialog,
  showDeleteDialog,
  showInfoDialog,
};
</script>

<style>
#text-size-18 {
  font-size: 18px;
}
</style>
